/*
 * SferyxUploadConnector.java
 *
 * Created on 2 luglio 2009, 12.20
 */

package org.sakaiproject.connector.sferyx;

import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.util.*;
import org.apache.commons.fileupload.*;
import org.sakaiproject.authz.api.*;
import org.sakaiproject.entity.api.*;
import org.sakaiproject.content.cover.*;
import org.sakaiproject.event.cover.*;
import org.sakaiproject.util.*;
import org.sakaiproject.tool.cover.*;

/**
 *
 * @author  Vassil Boyadjiev
 */
public class SferyxUploadConnector extends HttpServlet 
{
    
  
    
     public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException 
     {
         
         response.setContentType("text/html; charset=UTF-8");
         response.setHeader("Cache-Control","no-cache");
          
         
         
       String currentFolder = request.getParameter("CurrentFolder");
    
        
        PrintWriter out = response.getWriter();
             try
                {
                    DiskFileUpload fu = new DiskFileUpload();
                    // You can set some file size limit here...
                    fu.setSizeMax(10000000);
                    List fileItems = fu.parseRequest(request);
                    Iterator itr = fileItems.iterator();
                    int i=0;
                    while(itr.hasNext()) 
                    {
                           FileItem fi = (FileItem)itr.next();
                         
                                  if(!fi.isFormField()) 
                                  {
                                 

                                         String filePath = fi.getName();
                                         filePath = filePath.replace('\\','/');
                                         String[] pathParts = filePath.split("/");
                                         String fileName = pathParts[pathParts.length-1];
   
                                        
                                        
                                         ResourcePropertiesEdit resourceProperties = ContentHostingService.newResourceProperties();
                                         resourceProperties.addProperty (ResourceProperties.PROP_DISPLAY_NAME, fileName);

                                         String path=ContentHostingService.getProperties(currentFolder).getProperty(ContentHostingService.PROP_ALTERNATE_REFERENCE);// adjustFolder(currentFolder);
                                    
                                         
                                         
                                         if (path != null)
                                         {
                                             
                                             path=path.trim();
                                             
                                                 if(!path.equals("/") && !path.equals(""))
                                                  {
                                                       if (!path.startsWith(Entity.SEPARATOR))
                                                       {
                                                            path = Entity.SEPARATOR + path;
                                                       }
                                                       if (path.endsWith(Entity.SEPARATOR))
                                                       {
                                                            path = path.substring(0, path.length() - Entity.SEPARATOR.length());
                                                       }
                                                       
                                                     resourceProperties.addProperty (ContentHostingService.PROP_ALTERNATE_REFERENCE, path); 
                                                 }
                                         }

                                         int noti = NotificationService.NOTI_NONE;
                                         String mime = fi.getContentType();
                                         
                                         
                                       ContentHostingService.addResource(currentFolder+"sferyx/uploaded_files/"+fileName, mime, fi.get(),resourceProperties, noti);
                                    
                                    i++;
                                  }
                                  //The rest of the form fields are printed here
                                  else
                                  {

                                  }
                    }


             }
             catch(Throwable exc)
             {

                        exc.printStackTrace();
             } 
                finally
                {
                    if (out != null) 
                    {
                            out.close();
                       }
                }
         
         
         
     }

  
    
}
